package golock

import (
	"sync"
	"testing"
)

func TestLock(t *testing.T) {

	var counter int

	var l = NewLock()

	var wg sync.WaitGroup

	for i := 0; i < 10; i++ {
		wg.Add(1)
		go func() {
			defer wg.Done()
			if !l.Lock() {
				t.Error("上锁失败")
				return
			}
			counter++
			t.Log(counter)
			l.Unlock()
		}()
	}

	wg.Wait()
}
